/* -*- C++ -*- */
/**
 *  @file ID_Factory.h
 *
 *  ID_Factory.h,v 1.2 2002/10/27 06:12:32 pradeep Exp
 *
 *  @author Pradeep Gore <pradeep@oomworks.com>
 *
 *
 */

#ifndef TAO_NS_ID_FACTORY_H
#define TAO_NS_ID_FACTORY_H
#include "ace/pre.h"

#include "notify_export.h"

#if !defined (ACE_LACKS_PRAGMA_ONCE)
# pragma once
#endif /* ACE_LACKS_PRAGMA_ONCE */

#include "Types.h"
#include "ace/Atomic_Op.h"

/**
 * @class TAO_NS_ID_Factory
 *
 * @brief A simple factory for generating ID's for objects created by Notify.
 *
 */
class TAO_Notify_Export TAO_NS_ID_Factory
{
public:
  /// Constuctor
  TAO_NS_ID_Factory (void);

  /// Destructor
  ~TAO_NS_ID_Factory ();  

  TAO_NS_Object_Id id (void);

private:
  ACE_Atomic_Op<TAO_SYNCH_MUTEX, TAO_NS_Object_Id> seed_;
};


#if defined (__ACE_INLINE__)
#include "ID_Factory.inl"
#endif /* __ACE_INLINE__ */

#include "ace/post.h"
#endif /* TAO_NS_ID_FACTORY_H */
